<copyright> BIT tag.View extensions
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1997-1998 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: View.t,v 1.4 1998/03/23 16:11:44 tiggr Exp $</id>
    </copyright>

implementation class
View: posing tag.View

end;

implementation instance
View
{
  <doc> If our window is in {manipulating} mode, and this is {TRUE}, we
      are selected and draw an outline around our frame.  </doc>
  boolean selected;
}

void
  bitDeselect
{
  selected = NO;
}

void
  bitSelect
{
  selected = YES;
}

<doc> In addition to displaying (through {super}), draw a double-lined
    rectangle around the receiving view, if it is {selected}.  </doc>
void
  display (float, float, float, float) (x, y, w, h)
{
  [super display (x, y, w, h)];

  if (selected)
    {
      [self lockFocus];

      tag.Display d = [self currentDisplay];
      [d setColor [Color black]];
      [d unclip];
      [d drawRect (b_x - 1.0, b_y - 1.0, b_w + 2.0, b_h + 2.0)];
      [d drawRect (b_x - 2.0, b_y - 2.0, b_w + 4.0, b_h + 4.0)];
      [self unlockFocus];
    }
}

end;
