<copyright> TAG Rainbow example and ScrollView/ClipView test case.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Rainbow.t,v 1.10 1998/03/23 17:46:28 tiggr Exp $</id>
    </copyright>

implementation class
Rainbow: View, Conditions

int
  main Indexed arguments
{
  ConditionClass cc = condition;

  bind ((cc,
	 {
	   /* Report the condition and return it (to indicate we didn't
              handle it).  */
	   [[err print ("signal: ", condition)] nl];
	   condition;
	 }))
    ({
      /* Let TAG initialize itself, open displays, etc.  */
      Application app = [Application shared];
      tag.Display d;
      Indexed active_displays = [tag.Display active_displays];
      int i, n = [active_displays length];

      for (i = 0; i < n; i++)
	{
	  d = active_displays[i];
	  tag.Screen s = [d defaultScreen];
	  tag.Window w = [s windowWithContentRect (100.0, 100.0, 600.0, 600.0)
			    styleMask WINDOW_STYLE_TITLED
			    backing BACKING_STORE_RETAINED];

	  ScrollView sv = [[ScrollView alloc]
			    initFrame (100.0, 100.0, 400.0, 400.0)];
	  ClipView cp = [[ClipView alloc] initFrame (0.0, 0.0, 400.0, 400.0)];
	  Rainbow rb = [[self alloc] initFrame (0.0, 0.0, 900.0, 900.0)];
	  Slider slider_h, slider_v;
	  SliderCell sc;

	  [sv set_vertical_scroller_required YES];
	  [sv set_horizontal_scroller_required YES];

	  [sv set_content_view cp];
	  [sv set_document_view rb];
	  [sv set_auto_size VIEW_SIZE_WIDTH | VIEW_SIZE_HEIGHT];
	  [[w content_view] addSubview sv];

	  slider_v = [[Slider alloc] initFrame (10.0, 200.0, 10.0, 100.0)];
	  sc = SliderCell ([slider_v cell]);
	  [slider_v set_auto_size VIEW_SIZE_MAXX | VIEW_SIZE_MAXY];
	  [sc set_max_value 50.0];
	  [sc set_min_value -50.0];
	  [sc setDoubleValue 0.0];

	  [sc setTarget
	      [Invocation
		for selector ("v_moveViewVertically_r_toIndicatedBy_r")
		to: self with sv]];
	  [sc setAction selector ("v_toIndicatedBy_r")];
	  [sc set_continuous YES];

	  slider_h = [[Slider alloc] initFrame (200.0, 10.0, 100.0, 10.0)];
	  sc = SliderCell ([slider_h cell]);
	  [slider_v set_auto_size VIEW_SIZE_MAXX | VIEW_SIZE_MAXY];
	  [sc set_max_value 50.0];
	  [sc set_min_value -50.0];
	  [sc setDoubleValue 0.0];

	  [sc setTarget
	      [Invocation
		for selector ("v_moveViewHorizontally_r_toIndicatedBy_r")
		to: self with sv]];
	  [sc setAction selector ("v_toIndicatedBy_r")];
	  [sc set_continuous YES];

	  [[w content_view] addSubview slider_h];
	  [[w content_view] addSubview slider_v];
	  [w orderFront self];
	}

      if (!n)
	[[err print "no active displays"] nl];
      else
	[Application run];
    });
}

void
  moveViewHorizontally ScrollView v
	 toIndicatedBy Control sender
{
  [self move v by ([sender floatValue], 0.0)];
}

void
  moveViewVertically ScrollView v
       toIndicatedBy Control sender
{
  [self move v by (0.0, [sender floatValue])];
}

void
  move ScrollView v
    by (float, float) (dx, dy)
{
  float x, y;

  if (dx < 0.0)
    [[v scroller_h] set_continuous NO];
  if (dx > 0.0)
    [[v scroller_h] set_continuous YES];
  if (dy < 0.0)
    [[v scroller_v] set_continuous NO];
  if (dy > 0.0)
    [[v scroller_v] set_continuous YES];

  (x, y, , ) = [v frame];
  if (!!dx)
    x = 100.0 + dx;
  if (!!dy)
    y = 100.0 + dy;

  [v moveTo (x, y)];
  [[v window] display]; 
}

<doc> Do nothing.  Method exists just to get the selector known to the
    resolver.  </doc>
void
  toIndicatedBy Control sender
{
}

end;

implementation instance
Rainbow

void
  drawSelf (float, float, float, float) (x, y, w, h)
{
  MutableByteString buf = [MutableByteString new];
  tag.Display d = [self currentDisplay];
  float mx, my;

  {
    float wrx = b_x + 100.0, wry = b_y + 100.0;
    float wrw = b_w - 200.0, wrh = b_h - 200.0;

    [d setColor [Color white]];

    (wrx, wry, wrw, wrh) = [tag clipRect (wrx, wry, wrw, wrh) to (x, y, w, h)];
    [d fillRect (wrx, wry, wrw, wrh)];
  }

  [d setColor [Color dark]];
  if (y < 100.0)
    [d fillRect (x, y, w, 100.0 - y)];
  if (x < 100.0)
    [d fillRect (x, y, 100.0 - x, h)];
  if (y + h >= b_h - 100.0)
    [d fillRect (x, b_h - 100.0, w, y + h - (b_h - 100.0))];
  if (x + w >= b_w - 100.0)
    [d fillRect (b_w - 100.0, y, x + w - (b_w - 100.0), h)];

  [d drawLine (0.0, 0.0, b_w, b_h)];
  [d drawLine (0.0, b_h, b_w, 0.0)];

  [d setColor [Color black]];
  tag.Font font = [d systemFont];
  float height = [font height];
  [d setFont font];
  for (mx = 0.0; mx < b_w; mx += 200.0)
    for (my = 0.0; my < b_h; my += 200.0)
      {
	[buf truncate 0];
	[buf print ("(", mx, ",", my, ")")];

	float bufwidth = [font widthOf buf];
	boolean width_match = mx +  bufwidth >= x && mx < x + w;
	boolean height_match = my + height >= y && my < y + h;
	if (width_match && height_match
	    || (y < 100.0 && my < 100.0 && width_match)
	    || (x < 100.0 && mx < 100.0 && height_match)
	    || (y + h >= b_h - 100.0 && my + height >= b_h - 100.0
		&& width_match)
	    || (x + w >= b_w - 100.0 && mx + bufwidth >= b_w - 100.0
		&& height_match))
	  [d show buf at (mx, my)];
      }
}

end;
