<copyright> TAG ActionCell class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996-1998 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: ActionCell.t,v 1.12 1998/01/27 11:09:58 tiggr Exp $</id>
    </copyright>

implementation class
ActionCell: Action, Cell

end;

implementation instance
ActionCell
{
  <doc> This cell's tag.  </doc>
  int cell_tag;
}

int
  tag
{
  = cell_tag;
}

void
  setTag int t
{
  cell_tag = t;
}

void
  mouseUp MouseEvent e
       in Control v
{
  if (highlighted)
    [v sendAction [self action] to [self target]];
  [super mouseUp e in v];
}

/******************** Archiving ********************/
<doc><h4>Archiving</h4></doc>

void
  encodeUsingCoder Encoder coder
{
  if (![coder hasBeenCodedFor [ActionCell self]])
    {
      [super (Action) encodeUsingCoder coder];
      [super (Cell) encodeUsingCoder coder];
      [coder encode cell_tag];
    }
}

void
  initWithCoder Decoder coder
{
  if (![coder hasBeenCodedFor [ActionCell self]])
    {
      [super (Action) initWithCoder coder];
      [super (Cell) initWithCoder coder];
      cell_tag = [coder decode];
    }
}

end;
