<copyright> TAG BitmapImageRep class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: BitmapImageRep.t,v 1.5 1997/05/01 16:29:56 tiggr Exp $</id>
    </copyright>

implementation class
BitmapImageRep: ImageRep

<doc> Register us with the {ImageRep} class.  </doc>
redefine void
 load Array arguments
{
  [self registerImageRepClass self];
}

end;

implementation instance
BitmapImageRep
{
  <doc> The data planes.  {planes} points to an array of {num_planes}
      pointers.  </doc>
  public pointer planes;

  <doc> The number of planes.  This is 1 for meshed configuration.  </doc>
  public int num_planes;

  <doc> The number of bytes per full row.  </doc>
  public int bytes_per_row;

  <doc> The number of bits per sample.  </doc>
  public int bits_per_sample;

  <doc> The number of samples per pixel.  </doc>
  public int samples_per_pixel;

  <doc> The number of bits per pixel in each plane.  This is
      {bits_per_sample} for {planar} bitmaps, and {bits_per_sample *
      samples_per_pixel} for meshed bitmaps.  </doc>
  public int bits_per_pixel;

  <doc> The color space of this image.  </doc>
  public int color_space;

  <doc> Iff {TRUE}, this bitmap representation has an alpha channel.
      </doc>
  boolean alpha;

  <doc> Iff {TRUE}, samples for each of the color/transparency components
      are stored in a seperate plane.  </doc>
  boolean planar;
}

id
  initWithBitmapDataPlanes pointer p
		      size (float, float) (w, h)
	     bitsPerSample int bps
		  hasAlpha boolean has_alpha
		  isPlanar boolean config
		colorSpace int cs
	       bytesPerRow int row_bytes
{
  (planar, planes, alpha, color_space) = (config, p, has_alpha, cs);
  (bytes_per_row, bits_per_sample) = (row_bytes, bps);
  (width, height) = (w, h);

  if (color_space == COLOR_SPACE_DEVICE_RGB)
    samples_per_pixel = alpha ? 4 : 3;
  else if (color_space == COLOR_SPACE_DEVICE_WHITE)
    samples_per_pixel = alpha ? 2 : 1;
  else
    {
      [[Condition for self class program-condition
		  message [[MutableByteString new]
			    print ("unknown color space ", color_space)]]
	signal];
      return nil;
    }

  num_planes = planar ? samples_per_pixel : 1;

  bits_per_pixel = (planar ? bits_per_sample
		    : bits_per_sample * samples_per_pixel);

  [self setSize (w, h)];

  = self;
}

end;
