<copyright> TAG Constants.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996-1998 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Constants.t,v 1.17 1998/02/24 22:52:23 tiggr Exp $</id>
    </copyright>

implementation class
Constants: State
{
  <doc> {Window} backing store types.  </doc>
  const BACKING_STORE_RETAINED = 0;
  const BACKING_STORE_NONRETAINED = 1;
  const BACKING_STORE_BUFFERED = 2;

  <doc> {Window} styles mask.  </doc>
  const WINDOW_STYLE_PLAIN = 0;
  const WINDOW_STYLE_TITLED = 1;
  const WINDOW_STYLE_CLOSABLE = 2;
  const WINDOW_STYLE_MINIATURIZABLE = 4;
  const WINDOW_STYLE_RESIZABLE = 8;

  <doc> {Color} spaces.  </doc>
  const COLOR_SPACE_DEVICE_WHITE = 0;
  const COLOR_SPACE_DEVICE_RGB = 1;

  <doc> {Device} types.  </doc>
  const DEVICE_TYPE_SCREEN = 0;
  const DEVICE_TYPE_PRINTER = 1;

  <doc> {View} autosizing flexibility.  </doc>
  const VIEW_SIZE_NOT = 0;
  const VIEW_SIZE_MINX = 1;
  const VIEW_SIZE_WIDTH = 2;
  const VIEW_SIZE_MAXX = 4;
  const VIEW_SIZE_MINY = 8;
  const VIEW_SIZE_HEIGHT = 16;
  const VIEW_SIZE_MAXY = 32;

  <doc> Primitives of the above {View} flexibility.  </doc>
  const VIEW_SIZE_MIN = 1;
  const VIEW_SIZE_SPAN = 2;
  const VIEW_SIZE_MAX = 4;
  const VIEW_SIZE_X_SHIFT = 0;
  const VIEW_SIZE_Y_SHIFT = 3;
  const VIEW_SIZE_MASK = 0x7;

  <doc> {Event} types.  </doc>
  const EVENT_NULL = 0;
  const EVENT_MOUSE_DOWN = 1;
  const EVENT_MOUSE_DRAG = 2;
  const EVENT_MOUSE_UP = 3;

  <doc> {Event} key modifiers.  </doc>
  const EVENT_MOD_NONE = 0;
  const EVENT_MOD_SHIFT = 1;
  const EVENT_MOD_OPTION = 2;
  const EVENT_MOD_CONTROL = 4;
  const EVENT_MOD_COMMAND = 8;
  const EVENT_MOD_ALTERNATE = 16;

  <doc> Mask for the above.  </doc>
  const EVENT_MOD_MOD_ALL = 0x1f;

  <doc> This modifier bit is set if the key originated from the keypad.
      </doc>
  const EVENT_MOD_KEYPAD = 32;

  <doc> Compositing operations.  </doc>
  const COMPOSITE_COPY = 1;

  <doc> Box title types.  </doc>
  const BOX_TITLE_NONE = 0;
  const BOX_TITLE_TOP_ABOVE = 1;
  const BOX_TITLE_TOP_AT = 2;
  const BOX_TITLE_TOP_BELOW = 3;
  const BOX_TITLE_BOTTOM_ABOVE = 4;
  const BOX_TITLE_BOTTOM_AT = 5;
  const BOX_TITLE_BOTTOM_BELOW = 6;

  <doc> {Button} types.  </doc>
  const BUTTON_MOMENTARY_LIGHT = 0;
  const BUTTON_MOMENTARY_PUSH = 1;
  const BUTTON_MOMENTARY_CHANGE = 2;
  const BUTTON_PUSH_ON_PUSH_OFF = 3;
  const BUTTON_ON_OFF = 4;
  const BUTTON_TOGGLE = 5;
  const BUTTON_SWITCH = 6;
  const BUTTON_RADIO = 7;

  <doc> {ButtonCell} image positions.  </doc>
  const BUTTONCELL_IMAGE_NONE = 0;
  const BUTTONCELL_IMAGE_ONLY = 1;
  const BUTTONCELL_IMAGE_LEFT = 2;
  const BUTTONCELL_IMAGE_RIGHT = 3;
  const BUTTONCELL_IMAGE_BELOW = 4;
  const BUTTONCELL_IMAGE_ABOVE = 5;
  const BUTTONCELL_IMAGE_OVERLAP = 6;

  <doc> {ButtonCell} highlighting and state reflection masks.  </doc>
  const CELL_NO_MASK = 0;
  const CELL_MASK_PUSH = 1;
  const CELL_MASK_CONTENTS = 2;
  const CELL_MASK_CHANGE_GRAY = 4;
  const CELL_MASK_CHANGE_BACKGROUND = 8;
  const CELL_MASK_ALL = 15;

  <doc> Matrix modes.  </doc>
  const MATRIX_MODE_RADIO = 0;
  const MATRIX_MODE_HIGHLIGHT = 1;
  const MATRIX_MODE_LIST = 2;
  const MATRIX_MODE_TRACK = 3;

  <doc> Kinds of borders.  </doc>
  const BORDER_NONE = 0;
  const BORDER_LINE = 1;
  const BORDER_BEZEL = 2;
  const BORDER_GROOVE = 3;

  <doc> The default dimension of a scroller.  </doc>
  const SCROLLER_WIDTH = 19.0;
  const SCROLLER_CONFIG_PAGE = 1;
  const SCROLLER_CONFIG_SINGLE = 0;
  const SCROLLER_CONFIG_SINGLE_PAGE = 1;

  <doc> The hit parts of a scroller.  The order is fixed (and important).
      </doc>
  const SCROLLER_PART_BACKGROUND = -2;
  const SCROLLER_PART_NONE = -1;
  const SCROLLER_PART_KNOB = 0;
  const SCROLLER_PART_LESS = 1;
  const SCROLLER_PART_MORE = 2;
  const SCROLLER_PART_PAGE_LESS = 3;
  const SCROLLER_PART_PAGE_MORE = 4;
}

end;

implementation instance Constants end;
