<copyright> TAG Device class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Device.t,v 1.4 1998/03/03 00:17:23 tiggr Exp $</id>
    </copyright>

<doc> A {Device} does not include the physical size, since that size is
    meaningless on the screen.  A Printer could be a {Device} subclass
    which could include the paper size.  </doc>
implementation class
Device: State,
	tag

end;

implementation instance
Device

// Implement `int hash'.
// Mon Oct  7 15:46:45 1996, tiggr@jaguar.ics.ele.tue.nl

<doc> Have {d} tell whether it is equal to this {Device}.  </doc>
redefine boolean
  equal Device d
{
  = [d equalDevice self];
}

<doc> Have {d} tell whether it is equal to this {Device}.  </doc>
boolean
  equalDeviceDescription DeviceDescription d
{
  = [d equalDevice self];
}

<doc> Compare the features of this {Device} with {d}.  </doc>
boolean
  equalDevice Device d
{
  // CCC Tuple comparisons...
  // Mon Oct  7 15:42:52 1996, tiggr@jaguar.ics.ele.tue.nl
  float x1, x2, y1, y2;

  (x1, y1) = [self resolution];
  (x2, y2) = [d resolution];
  if (x1 != x2 || y1 != y2)
    return NO;

  = ([self isScreen] == [d isScreen]
     && [self colorSpace] == [d colorSpace]
     && [self bitsPerSample] == [d bitsPerSample]);
}

<doc> Return the device's bits per sample.  </doc>
deferred int
  bitsPerSample;

<doc> Return the device's color space.  </doc>
deferred int
  colorSpace;

<doc> Return the frame of the receiving device.  </doc>
deferred (float, float, float, float)
  frame;

<doc> Return {YES} if the device is on a screen or intended to be
    displayed on one.  Default implementation returns {NO}.  </doc>
boolean
  isScreen
{
  = FALSE;
}

<doc> Return {YES} if the device is a printer.  Default implementation
    returns {NO}.  </doc>
boolean
  isPrinter
{
  = FALSE;
}

<doc> Return the resulution of the device, in pixels per inch.  </doc>
deferred (float, float)
  resolution;

end;
