<copyright> TAG Event class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Event.t,v 1.4 1997/07/27 14:23:04 tiggr Exp $</id>
    </copyright>

/******************** Event ********************/

implementation class
Event: State, Copying,
	tag

end;

implementation instance
Event
{
  <doc> The event type.  </doc>
  public int type;

  <doc> The {Window} on which this event occured.  </doc>
  public Window window;
}

<doc> Designated (re-)initializer.  </doc>
id (self)
    init int t
  window Window w
{
  (type, window) = (t, w);
}

end;

/******************** UserEvent ********************/

<doc> A {UserEvent} is an event originating from the user, with modifiers
    and all that information.  </doc>
implementation class
UserEvent: Event

end;

implementation instance
UserEvent
{
  <doc> Any modifier information.  </doc>
  public int modifiers;
}

<doc> Designated (re-)initializer.  </doc>
id
       init int t
     window Window w
  modifiers int mods
{
  modifiers = mods;
  = [super init t window w];
}

<doc> Return the modifiers actually related to an extra key being pressed.
    </doc>
int
  keyModifiers
{
  = modifiers & EVENT_MOD_MOD_ALL;
}

end;

/******************** MouseEvent ********************/

implementation class
MouseEvent: UserEvent

end;

implementation instance
MouseEvent
{
  <doc> The location, in window coordinates, of the event.  </doc>
  public float x, y;

  <doc> Status of the buttons.  </doc>
  public int buttons;
}

<doc> Designated (re-)initializer.  </doc>
id
       init int t
     window Window w
  modifiers int mod
    buttons int b
   location (float, float) (loc_x, loc_y)
{
  (buttons, x, y) = (b, loc_x, loc_y);
  = [super init t window w modifiers mod];
}

<doc> Return the location of the event, in window coordinates.  </doc>
(float, float)
  location
{
  = (x, y);
}

<doc> Set the location.  This can be used by a {Window} to convert the
    coordinates from the underlying system to TAG coordinates.  </doc>
void
  set_location (float, float) (loc_x, loc_y)
{
  (x, y) = (loc_x, loc_y);
}

end;
