<copyright> TAG Responder class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Responder.t,v 1.9 1998/03/09 00:01:38 tiggr Exp $</id>
    </copyright>

implementation class
Responder: tag

end;

implementation instance
Responder
{
  <doc> The next {Responder} in the responder chain.  </doc>
  id next_responder;
}

<doc> Return {TRUE} iff the receiving responder wants to become the first
    responder, as triggered by the {event}.  The default implementation
    returns {FALSE}.  </doc>
boolean
  acceptsFirstResponder MouseEvent event
pre
  [event type] == EVENT_MOUSE_DOWN
{
}

<doc> Return {TRUE}.  </doc>
boolean
  becomeFirstResponder
{
  = TRUE;
}

<doc> Return {TRUE} if the receiving responder accepts losing its first
    responder status.  The default implementation returns {TRUE}.  </doc>
boolean
  resignFirstResponder
{
  = TRUE;
}

<doc> Find, in the responder chain, a responder understanding the
    {action}, and have it perform the {action} with the {sender} argument.
    If no suitable responder is found, return {FALSE}.  </doc>
boolean
  tryToSendAction selector action
	     from All sender
{
  if ([self respondsTo action])
    {
      [self perform action with sender];
      = TRUE;
    }
  else if (next_responder != nil)
    = [next_responder tryToSendAction action from sender];
}

<doc> Do nothing.  </doc>
void
  mouseDown MouseEvent event
{
}

<doc> Do nothing.  </doc>
void
  mouseDragged MouseEvent event
{
}

<doc> Do nothing.  </doc>
void
  mouseUp MouseEvent event
{
}

deferred void
  cut All object;

deferred void
  copy All object;

deferred void
  paste All object;

deferred void
  undo All object;

deferred void
  redo All object;

/******************** Archiving ********************/
<doc> <h4>Archiving</h4> </doc>

void
  encodeUsingCoder Encoder coder
{
  if (![coder hasBeenCodedFor [Responder self]])
    {
      [super encodeUsingCoder coder];
      [coder encode next_responder];
    }
}

void
  initWithCoder Decoder coder
{
  if (![coder hasBeenCodedFor [Responder self]])
    {
      [super initWithCoder coder];
      next_responder = [coder decode];
    }
}

end;
