<copyright> TAG Screen class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Screen.t,v 1.8 1998/04/15 22:38:36 tiggr Exp $</id>
    </copyright>

implementation class
Screen: State

end;

implementation instance
Screen
{
  <doc> The {Display} on which this {Screen} resides.  </doc>
  public Display display;
}

<doc> Return the {Device} describing this {Screen}.  </doc>
deferred Device
  deviceDescription;

<doc> Return the {Window} class object to be used to create windows on
    this screen.  </doc>
deferred class (Window)
  windowClass;

<doc> Return the {Panel} class object to be used to create panels on
    this screen.  </doc>
deferred class (Panel)
  panelClass;

<doc> Create a new window on this screen.  </doc>
Window
  windowWithContentRect (float, float, float, float) (x, y, w, h)
	      styleMask int style
		backing int backing
{
  // What if I want a special kind of Window in my application,
  // irrespective of the current display/screen?  Currently, the only way
  // to do this is posing, but that affects the whole tag.Window class,
  // and all its subclasses and their instances...
  // Mon Jul  7 21:28:58 1997, tiggr@tricky.es.ele.tue.nl
  = [[[self windowClass] alloc] initWithContentRect (x, y, w, h)
				styleMask style backing backing screen self];
}

<doc> Create a new panel on this screen.  </doc>
Panel
  panelWithContentRect (float, float, float, float) (x, y, w, h)
	     styleMask int style
	       backing int backing
{
  // What if I want a special kind of Window in my application,
  // irrespective of the current display/screen?  Currently, the only way
  // to do this is posing, but that affects the whole tag.Window class,
  // and all its subclasses and their instances...
  // Mon Jul  7 21:28:58 1997, tiggr@tricky.es.ele.tue.nl
  = [[[self panelClass] alloc] initWithContentRect (x, y, w, h)
			       styleMask style backing backing screen self];
}

end;
