<copyright> TAG tag class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996-1998 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: tag.t,v 1.11 1998/03/02 10:35:47 tiggr Exp $</id>
    </copyright>

implementation class
tag: State, stdio, Conditions, Constants
{
  <doc> Iff we're printing in this thread, this is the printer's
      {Display}.  </doc>
  local static Display printer_display;

  <doc> For any {View} objects created in this thread, this {Display} will
      supply the {systemFont} and other goodies.  </doc>
  local static Display system_display;
}

OutputStream
  error
{
  = [err print ("tag:", [self name], ": ")];
}

/******************** Rectangles ********************/

<doc> Adjust the point to lie within the rectangle.  </doc>
(float, float) (x, y)
  clipPoint (float, float) (x, y)
	 to (float, float, float, float) (x1, y1, w1, h1)
{
  if (x < x1)
    x = x1;
  else if (x >= x1 + w1)
    x = x1 + w1 - 1.0;

  if (y < y1)
    y = y1;
  else if (y >= y1 + h1)
    y = y1 + h1 - 1.0;
}

<doc> Return that part of the first line that has all its points in common
    with the second line.  Both lines start at {x} and run for {l}
    `pixels'.  </doc>
(float, float)
  clipLine (float, float) (x1, l1)
	to (float, float) (x2, l2)
{
  /* Fully left.  */
  if (x1 + l1 <= x2)
    return (x2, 0.0);

  /* Fully right.  */
  if (x1 >= x2 + l2)
    return (x2 + l2, 0.0);

  /* Enter left.  */
  if (x1 < x2)
    {
      l1 -= x2 - x1;
      x1 = x2;
    }

  /* Enter right.  */
  if (x1 + l1 > x2 + l2)
    l1 = x2 + l2 - x1;

  = (x1, l1 > 0.0 ? l1 : 0.0);
}

<doc> Return that part of the first rectangle that lies within the second
    rectangle.  </doc>
(float, float, float, float)
  clipRect (float, float, float, float) (x1, y1, w1, h1)
	to (float, float, float, float) (x2, y2, w2, h2)
{
  (x1, w1) = [self clipLine (x1, w1) to (x2, w2)];
  (y1, h1) = [self clipLine (y1, h1) to (y2, h2)];

  = (x1, y1, w1, h1);
}

<doc> Return {TRUE} iff there is at least one point common to both
    argument rectangles.  </doc>
boolean
	rect (float, float, float, float) (x1, y1, w1, h1)
  intersects (float, float, float, float) (x2, y2, w2, h2)
{
  = (((x1 >= x2 && x1 < x2 + w2)
      || (x1 + w1 >= x2 && x1 + w1 < x2 + w2)
      || (x2 >= x1 && x2 < x1 + w1))
     && ((y1 >= y2 && y1 < y2 + h2)
	 || (y1 + h1 >= y2 && y1 + h1 < y2 + h2)
	 || (y2 >= y1 && y2 < y1 + h1)));
}

<doc> Return the rectangle enclosing just both argument rectangles.  If
    either rectangle has a zero width or height, the other rectangle is
    returned.  </doc>
(float, float, float, float)
  unionRect (float, float, float, float)  (x1, y1, w1, h1)
       with (float, float, float, float) (x2, y2, w2, h2)
{
  if (w1 == 0.0 || h1 == 0.0)
    return (x2, y2, w2, h2);
  if (w2 == 0.0 || h2 == 0.0)
    return (x1, y1, w1, h1);

  if (x1 > x2)
    {
      w1 += x1 - x2;
      x1 = x2;
    }
  if (y1 > y2)
    {
      h1 += y1 - y2;
      y1 = y2;
    }
  if (x1 + w1 < x2 + w2)
    w1 = x2 + w2 - x1;
  if (y1 + h1 < y2 + h2)
    h1 = y2 + h2 - y1;

  = (x1, y1, w1, h1);
}

<doc> Return {TRUE} iff the point {(p_x, p_y)} lies within the rectangle
    described by {(x, y, w, h)}.  </doc>
boolean
   point (float, float) (p_x, p_y)
  inRect (float, float, float, float) (x, y, w, h)
{
  = p_x >= x && p_x < x + w && p_y >= y && p_y < y + h;
}

end;

implementation instance
tag

OutputStream
  error
{
  = [err print ("tag:", [isa name], ": ")];
}

// This is a very nasty hack to het the selector type known to the resolver.
// Fri Jan  2 14:04:44 1998, tiggr@tnt.ics.ele.tue.nl
deferred String substring (int, int) (a, b);

end;
