<copyright> X TAG CachedImageRep class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: CachedImageRep.t,v 1.6 1998/02/24 17:23:17 tiggr Exp $</id>
    </copyright>

<doc> The X {CachedImageRep} can do slow caching, using ximages, and fast
    caching using pixmaps.  The distinction is to please memory restricted
    X servers.  </doc>
implementation class
CachedImageRep: tag.CachedImageRep

<doc> Register us with the {ImageRep} class.  </doc>
redefine void
 load Array arguments
{
  [self registerImageRepClass self];
}

extern instance (id)
  withSize (float, float) (x, y)
  onScreen Screen screen;

extern instance (id)
  withBitmapImageRep BitmapImageRep rep
	    onScreen Screen screen;

end;

implementation instance
CachedImageRep
{
  <doc> The {Screen} on which we are `locked'.  </doc>
  public Screen screen;

  <doc> Pointer to the underlying XImage structure, if we have one.  </doc>
  public pointer ximage;

  <doc> The xid of the Pixmap, if we have one.  </doc>
  int pixmap;
}

id
  init (Screen, pointer, int) (s, x, pixmap_x_id)
{
  (screen, ximage, pixmap) = (s, x, pixmap_x_id);

  = self;
}

<doc> Deallocate the {pixmap} and {ximage}.  </doc>
extern void
  dealloc;

boolean
  drawAtPoint (float, float) (x, y)
{
  [x.Display ([Display current]) drawImage self at (x, y)];
}

<doc> Return the {pixmap}.  If the {ximage} is small enough, the pixmap is
    created on the fly, and returned.  </doc>
extern int
  pixmap;

end;
