<copyright> X TAG Font class.
    Written by <a href="mailto:tiggr@es.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 1996, 1997 Pieter J. Schoenmakers.
    All rights reserved.

    This file is part of TAG.  TAG is distributed under the terms of the
    TAG License, a copy of which can be found in the TAG distribution; see
    the file LICENSE.

    <id>$Id: Font.t,v 1.5 1997/07/02 21:15:23 tiggr Exp $</id>
    </copyright>

implementation class
Font: tag.Font

end;

implementation instance
Font
{
  <doc> This font's name  </doc>
  public String name;

  <doc> The underlying X font structure.  </doc>
  public pointer font;

  <doc> The display to which we belong.  </doc>
  public Display display;
}

id
  init String n
  font pointer f
    on Display d
{
  (name, font, display) = (n, f, d);

  = self;
}

<doc> Make this font the current font of the current display.  </doc>
void
  set
{
  [[Display current] setFont self];
}

extern float
  ascent;

extern float
  descent;

extern float
  height;

extern float
  widthOf String text;


/******************** Archiving ********************/
<doc> <h4>Archiving</h4> </doc>

void
  encodeUsingCoder Encoder coder
{
  if (![coder hasBeenCodedFor [Font self]])
    {
      [super encodeUsingCoder coder];
      [coder encode name];
    }
}

void
  initWithCoder Decoder coder
{
  if (![coder hasBeenCodedFor [Font self]])
    {
      [super initWithCoder coder];
      name = [coder decode];
    }
}

id
  awakeAfterUsingCoder Decoder coder
{
  display = Display (system_display);
  font = [display loadFont name];

  = [super awakeAfterUsingCoder coder];
}

end;
